package matsubara.carcontroller;

import matsubara.gear.*;


/**
 * <p>^Cg: sgrV~[^</p>
 * <p>: vEX̃nCubhVXeisgrj̐SAVԋ@\̃V~[V</p>
 * <p>쌠: Copyright (c) 2002 m.matsubara </p>
 * @author m.matsubara
 * @version 1.2.0
 */

public class ThsController extends CarController {
  PlanetaryGear m_planetaryGear;
  boolean m_bGasoline;
  boolean m_bMotor;
  boolean m_bKaisei;
  double m_rBatterySOC = 60.0;      //  guobe[cʁiSOC = State of chargej;
  boolean m_bEngineRequest = false; //  guobe[ȂƂiSOjnm@@TOɂȂ܂
  boolean m_bPowerSaveMode = false; //  J
  //  THS 샂[h
  /** GlM[̗Ȃ */
  public static final int thsStop = 0;
  /** ~ŏ[d */
  public static final int thsStopAndEngine = 1;
  /** [^[݂̂Ŕi */
  public static final int thsStart = 2;
  /** ʏ^] */
  public static final int thsNormal = 3;
  /** ʏ^](I[o[hCuE[^[Ɣd@̖t]) */
  public static final int thsNormalOD = 4;
  /** SJiGW+[^[j */
  public static final int thsFullAccel = 5;
  /** SJiGW+[^[j */
  public static final int thsFullAccelOD = 6;
  /** 񐶃u[L */
  public static final int thsKaisei = 7;
  /** 񐶃u[L{GW͔d@ׂ̕œĂ */
  public static final int thsKaiseiAndEngine = 8;
  /** [^[݂̂Ŕi */
  public static final int thsBackAndEngine = 9;
  /** 샂[h */
  int m_nThsMode = thsStop;

  /**
   * ThsController ̏
   * @param nPlanetaryGearX vl^MA`ƂXW
   * @param nPlanetaryGearY vl^MA`ƂXW
   * @param nPlanetaryGearSize vl^MA`Ƃ̃TCYiaj
   */
  public ThsController(int nPlanetaryGearX, int nPlanetaryGearY, int nPlanetaryGearSize) throws EPlanetaryGear {
    super();
    m_planetaryGear = new PlanetaryGear(nPlanetaryGearX, nPlanetaryGearY, nPlanetaryGearSize, 30, 23, 78, 4, 4); //  ͕@\
    setFuel(50);  //  R^
  }

  /**
   * Vtg|WV̐ݒiSutj
   * SuiHjtĂ邽DW炢Ȃ P  R ɓ肵ȂB
   * @param sShiftPosition VVtg|WV
   */
  public void setShiftPosition(String sShiftPosition) {
    double rSpeed = getSpeed();
    if (sShiftPosition.equals("P")) {
      if (rSpeed == 0)
        super.setShiftPosition(sShiftPosition);
      else
        super.setShiftPosition("N");
    }
    else if (sShiftPosition.equals("R")) {
      if (rSpeed <= 0)
        super.setShiftPosition(sShiftPosition);
      else
        super.setShiftPosition("N");
    }
    else if (sShiftPosition.equals("N"))
      super.setShiftPosition(sShiftPosition);
    else if (sShiftPosition.equals("D") || sShiftPosition.equals("B")) {
      if (rSpeed >= 0)
        super.setShiftPosition(sShiftPosition);
      else
        super.setShiftPosition("N");
    }
  }

  /**
   * Ԃ̏ԂV~[g
   * @param rMilliSec oߕb
   * @param nAccel ANZ̓ݍݗ(%)
   * @param nBrake u[L̓ݍݗ(%)
   */
  protected void driveInternal(double rMilliSec, int nAccel, int nBrake) {
    String sShiftPosition = getShiftPosition();
    if (getFuel() <= 0) {
      //  C`LKXf
      nAccel = 0;
      nBrake = 30;
    }

    if (sShiftPosition.equals("D"))
      driveInternal_D_B(rMilliSec, nAccel, nBrake);
    else if (sShiftPosition.equals("B"))
      driveInternal_D_B(rMilliSec, nAccel, nBrake);
    else if (sShiftPosition.equals("R"))
      driveInternal_R(rMilliSec, nAccel, nBrake);
    else if (sShiftPosition.equals("P"))
      driveInternal_P(rMilliSec, nAccel, nBrake);
    else
      driveInternal_N(rMilliSec, nAccel, nBrake);     //  N W

    m_bMotor = (m_nThsMode == thsStart) || (m_nThsMode == thsFullAccel) || (m_nThsMode == thsFullAccelOD) || (m_nThsMode == thsBackAndEngine);
    m_bKaisei = (m_nThsMode == thsKaisei) || (m_nThsMode == thsKaiseiAndEngine);
    m_bGasoline = (m_nThsMode == thsFullAccel) || (m_nThsMode == thsFullAccelOD) || (m_nThsMode == thsNormal) || (m_nThsMode == thsNormalOD) || (m_nThsMode == thsStopAndEngine)|| (m_nThsMode == thsBackAndEngine);

    if (m_rBatterySOC > 80.0)
      m_rBatterySOC = 80.0;
    if ((m_bEngineRequest == false) && (m_rBatterySOC < 45)) {
      m_bEngineRequest = true;
      System.out.println("m_bEngineRequest = true");
    }
    if (m_rBatterySOC < 40)
      m_bPowerSaveMode = true;
    if ((m_bEngineRequest != false) && (m_rBatterySOC >= 50)) {
      m_bEngineRequest = false;
      m_bPowerSaveMode = false;
      System.out.println("m_bEngineRequest = false");
    }
  }

  private double engineRpm(double rTargetEngineRpm, double rMilliSec) {
    //  ]̐
    double rEngineRpm = m_planetaryGear.getPlaCarrierSpeed();
    if (rEngineRpm < rTargetEngineRpm) {
      rEngineRpm += (rMilliSec / 1000) * 1000;
      if (rEngineRpm > rTargetEngineRpm)
        rEngineRpm = rTargetEngineRpm;
    }
    else if (rEngineRpm > rTargetEngineRpm) {
      rEngineRpm -= (rMilliSec / 1000) * 2000;
      if (rEngineRpm < rTargetEngineRpm)
        rEngineRpm = rTargetEngineRpm;
    }
    return rEngineRpm;
  }

  /**
   * PW̎̃V~[V
   * @param rMilliSec oߕb
   * @param nAccel ANZ̓ݍݗ(%)
   * @param nBrake u[L̓ݍݗ(%)
   */
  private void driveInternal_P(double rMilliSec, int nAccel, int nBrake) {
    m_nThsMode = thsStop;

    //  sgreڕWl
    double rTargetEngineRpm = 0;

    //  GW̏
    if (nAccel >= 5) {
      //  GWR
      rTargetEngineRpm = 1000 + nAccel * 500 / 100 ;
    }

    //@obe[̏ԂƂ
    if (m_bEngineRequest) {
      if (rTargetEngineRpm < 1250)
        rTargetEngineRpm = 1250;
      rTargetEngineRpm = 1250;
      m_nThsMode = thsStopAndEngine;
      m_rBatterySOC += 0.00010 * rMilliSec;
    }

    //  ]̐
    double rEngineRpm = engineRpm(rTargetEngineRpm, rMilliSec);

    m_planetaryGear.setRingGearSpeed(0);
    m_planetaryGear.setPlaCarrierSpeed(rEngineRpm);
    m_planetaryGear.move(rMilliSec / 100);
  }

  /**
   * RW̎̃V~[V
   * @param rMilliSec oߕb
   * @param nAccel ANZ̓ݍݗ(%)
   * @param nBrake u[L̓ݍݗ(%)
   */
  private void driveInternal_R(double rMilliSec, int nAccel, int nBrake) {
    m_nThsMode = thsStop;

    //  sgrel
    double rSpeed = getSpeed();

    //  sgreڕWl
    double rTargetSpeed = - 5 - (double)(nAccel * 35 / 100);
    double rTargetEngineRpm = 0;
    if (m_bEngineRequest) {
      if (rTargetSpeed < -16)
        rTargetSpeed = -16;
      rTargetEngineRpm = 1200;
    }
    if (m_bPowerSaveMode == false && m_bEngineRequest && rSpeed < -5)  //  GW]vĂx -5km/h 葬Ƃ̓GW񂳂ȂB
      rTargetEngineRpm = 0;

    double rEngineRpm = engineRpm(rTargetEngineRpm, rMilliSec);

    //  EŘvZ
    m_bMotor = true;
    m_nThsMode = thsStart;
    if (rSpeed > rTargetSpeed) {
      //  ̌vZ
      rSpeed += (rTargetSpeed - rSpeed) * rMilliSec / 1000 * 0.15;
      if (rSpeed < rTargetSpeed)
        rSpeed = rTargetSpeed;
    }
    else {
      rSpeed += 2.20 * rMilliSec / 1000;

      if (rSpeed > rTargetSpeed)
        rSpeed = rTargetSpeed;
      if (rSpeed < -10)
        m_nThsMode = thsKaisei;
    }
    if (rEngineRpm > 1000)
      m_nThsMode = thsBackAndEngine;

    //  u[L̔f
    if (isParkingBrake() && nBrake < 50)
      nBrake = 50;  //  p[LOu[L𕁒ʂ̃u[L50%Ƃ݂ȂB
    if (nBrake > 5) {
      rSpeed += 0.25 * nBrake * rMilliSec / 1000;
      if (rSpeed > 0)
        rSpeed = 0;
      if (rSpeed < -10)
        m_nThsMode = thsKaisei;
      else
        m_nThsMode = thsStop;
    }

    //  GW]ĂđxO̎
    if (rEngineRpm > 1000 && rSpeed == 0)
      m_nThsMode = thsStopAndEngine;

    if (m_nThsMode == thsStart)
      m_rBatterySOC -= rSpeed * -0.0000030 * rMilliSec;
    else if (m_nThsMode == thsKaisei)
      m_rBatterySOC += rSpeed * -0.0000010 * rMilliSec;
    else if (m_nThsMode == thsBackAndEngine)
      m_rBatterySOC += 0.0000020 * rMilliSec;
    else if (m_nThsMode == thsStopAndEngine)
      m_rBatterySOC += 0.00010 * rMilliSec;

//    double rTyreDiameter = 165 * 0.65 * 2 + 15 * 25.4;
    double rTyreDiameter = 285 * 2;
    double rTyreGirth = rTyreDiameter * Math.PI;
    double rRingGear = (3.927 / rTyreDiameter / Math.PI / 60 * 1000 * 1000) * rSpeed;

    m_planetaryGear.setRingGearSpeed(rRingGear);
    m_planetaryGear.setPlaCarrierSpeed(rEngineRpm);
    m_planetaryGear.move(rMilliSec / 100);
  }

  /**
   * NW̎̃V~[V
   * @param rMilliSec oߕb
   * @param nAccel ANZ̓ݍݗ(%)
   * @param nBrake u[L̓ݍݗ(%)
   */
  private void driveInternal_N(double rMilliSec, int nAccel, int nBrake) {
    double rSpeed = getSpeed();
    //  mWł͉񐶃u[LgȂ̂Ńu[L̗ɂ
    if  (rSpeed > 0) {
      rSpeed -= (1.4 + rSpeed / 100 * 1.5) * rMilliSec / 1000 * 0.5;      //  R
      rSpeed -= (0.20 + rSpeed / 100 * 0.8) * nBrake * rMilliSec / 1000 * 0.5;  //  u[L
      if (rSpeed < 0)
        rSpeed = 0;
    }
    else if (rSpeed < 0) {
      rSpeed += (1.4 + rSpeed / 100 * 1.5) * rMilliSec / 1000 * 0.5;      //  R
      rSpeed += (0.20 + rSpeed / 100 * 0.8) * nBrake * rMilliSec / 1000 * 0.5;  //  u[L
      if (rSpeed > 0)
        rSpeed = 0;
    }

//    double rTyreDiameter = 165 * 0.65 * 2 + 15 * 25.4;
    double rTyreDiameter = 285 * 2;
    double rTyreGirth = rTyreDiameter * Math.PI;
    double rRingGear = (3.927 / rTyreDiameter / Math.PI / 60 * 1000 * 1000) * rSpeed;

    m_planetaryGear.setRingGearSpeed(rRingGear);
    m_planetaryGear.setPlaCarrierSpeed(0);
    m_planetaryGear.move(rMilliSec / 100);
    m_nThsMode = thsStop;
  }

  /**
   * DWBW̎̃V~[V
   * @param rMilliSec oߕb
   * @param nAccel ANZ̓ݍݗ(%)
   * @param nBrake u[L̓ݍݗ(%)
   */
  private void driveInternal_D_B(double rMilliSec, int nAccel, int nBrake) {
    //  sgrel
    double rSpeed = getSpeed();
    double rEngineRpm = m_planetaryGear.getPlaCarrierSpeed();

    //  sgreڕWl
    double rTargetSpeed = 13 + nAccel * 1.6;
    double rTargetEngineRpm = 0;

    //  GW̏
//    double rEngineStopSpeed = (m_rBatterySOC >= 45) ? 45 : 40;    //  GW~xiGWƃ[^[̑x̋Ej
    double rEngineStopSpeed = 45;
    double rMoterAccelDiff = (m_rBatterySOC >= 50) ? 20 : 10;  //  [^[݂̂ł̉̂₷il̑傫[^[݂̂ŉ₷j
    if ((rSpeed >= rEngineStopSpeed || rSpeed < rTargetSpeed - rMoterAccelDiff) && nAccel >= 10) {
      //  GWR
      rTargetEngineRpm = 1150 + (rTargetSpeed - 40) * (rTargetSpeed - 40) * 2850 / 10000 ;
      if (rTargetEngineRpm > 4000)
        rTargetEngineRpm = 4000;
      if (rEngineRpm >= 1000)
        m_nThsMode = thsNormal;
      else
        m_nThsMode = thsStart;
    }
    else if (rSpeed >= 3 && rSpeed < 15 && rEngineRpm >= 1000) {
      rTargetEngineRpm = 1150;
      m_nThsMode = thsNormal;
    }
    else {
      //  GW͔d@ɂĉ񂳂Ă邩A܂͎~܂ĂiRĂĂȂj
      rTargetEngineRpm = 1000 + (rSpeed - 50) * 10;
      if (rSpeed < 45)
        rTargetEngineRpm = 0;
      m_nThsMode = thsStart;
    }

    //  guobe[rnbȂƂ
    //  iu[L𓥂łāAȂxPT^ȏłȂƂj́AGW~߂邱Ƃ
    if (m_bPowerSaveMode) {
      if (nBrake <= 5 || rSpeed < 15) {
        rTargetEngineRpm += 100;
        rTargetEngineRpm = rTargetEngineRpm > 1250 ? rTargetEngineRpm : 1250;
        rTargetEngineRpm = rTargetEngineRpm < 4000 ? rTargetEngineRpm : 4000;
      }
      if (rSpeed != 0)
        m_nThsMode = thsNormal;
      if (rTargetSpeed >= 140)
        rTargetSpeed = 140;
    }

    rEngineRpm = engineRpm(rTargetEngineRpm, rMilliSec);

    //  EŘvZ
    if (rSpeed < rTargetSpeed) {
      //  ̌vZ
      double rMaxPowerRatio = 0.5 + (160 - rSpeed) / 320;
      if (m_bPowerSaveMode)
        rMaxPowerRatio *= 0.9;  //  J[h͉͓݂̎
      if (getShiftPosition().equals("D"))
        rSpeed += Math.pow(rTargetSpeed - rSpeed, 0.9) * rMilliSec / 1000 * 0.120 * rMaxPowerRatio; //  D W̉
      else
        rSpeed += Math.pow(rTargetSpeed - rSpeed, 0.9) * rMilliSec / 1000 * 0.111 * rMaxPowerRatio; //  B W̉
      if (rSpeed > rTargetSpeed)
        rSpeed = rTargetSpeed;
      if ((rSpeed < rTargetSpeed - 15) || (rTargetSpeed > 140) || (rEngineRpm == 0)) {
        if (rEngineRpm >= 1000) {
          if (m_bPowerSaveMode == false)
            m_nThsMode = thsFullAccel;
        }
        else
          m_nThsMode = thsStart;  //@ȉ
      }
    }
    else {
      //  R
      double rBrakeRatio = 1.0; //  cŴƂ̎R̊Ƃ̔r
      if (getShiftPosition().equals("B"))
        rBrakeRatio = 1.4;  //  aW̔䗦
      rSpeed -= (1.4 + rSpeed / 100 * 1.5) * rMilliSec / 1000 * rBrakeRatio;
      if (rSpeed < rTargetSpeed)
        rSpeed = rTargetSpeed;
      if ((nAccel == 0) && (rSpeed > 15))
          m_nThsMode = thsKaisei;
      m_nThsMode = thsKaisei;
    }

    //  u[L̔f
    if (isParkingBrake() && nBrake < 50)
      nBrake = 50;  //  p[LOu[L𕁒ʂ̃u[L50%Ƃ݂ȂB
    if (nBrake > 5) {
      rSpeed -= (0.20 + rSpeed / 100 * 0.8) * nBrake * rMilliSec / 1000;
      if (rSpeed < 0)
        rSpeed = 0;
      if (rSpeed > 10)
        m_nThsMode = thsKaisei;
      else
        m_nThsMode = thsStop;
    }

    if ((m_nThsMode == thsKaisei) && (rTargetEngineRpm > 0))
      m_nThsMode = thsKaiseiAndEngine;
    if ((m_nThsMode == thsStop) && rEngineRpm >= 1250)
      m_nThsMode = thsStopAndEngine;

//    double rTyreDiameter = 165 * 0.65 * 2 + 15 * 25.4;
    double rTyreDiameter = 285 * 2;
    double rTyreGirth = rTyreDiameter * Math.PI;
    double rRingGear = (int)((3.927 / rTyreDiameter / Math.PI / 60 * 1000 * 1000) * rSpeed);

    m_planetaryGear.setRingGearSpeed(rRingGear);
    m_planetaryGear.setPlaCarrierSpeed(rEngineRpm);

    //  d@̉]ɒ[ɂȂȂ悤ɃGW̉]𒲐
    if (m_planetaryGear.getSunGearSpeed() > 6000)
      m_planetaryGear.setSunGearSpeed(6000);
    else if (m_planetaryGear.getSunGearSpeed() < -4500)
      m_planetaryGear.setSunGearSpeed(-4500);
    if ((m_nThsMode == thsNormal) && (m_planetaryGear.getSunGearSpeed() < 300))
      m_nThsMode = thsNormalOD;   //  d@ 300rpm ŔdiƉ肷ĵƂAI[o[hCuԂłƂ݂ȂB
    if ((m_nThsMode == thsFullAccel) && (m_planetaryGear.getSunGearSpeed() < 300))
      m_nThsMode = thsFullAccelOD;   //  d@ 300rpm ŔdiƉ肷ĵƂAI[o[hCuԂłƂ݂ȂB

    m_planetaryGear.move(rMilliSec / 100);  //  vl^MA]

    switch (m_nThsMode) {
    case thsStart:
    case thsFullAccel:
    case thsFullAccelOD:
      m_rBatterySOC -= (rSpeed) * 0.0000022 * rMilliSec + (rTargetSpeed - rSpeed) * 0.0000015 * rMilliSec;
      break;
    case thsKaisei:
    case thsKaiseiAndEngine:
      m_rBatterySOC += (rSpeed - rTargetSpeed) * 0.000001 * rMilliSec;
      break;
    case thsNormal:
    case thsNormalOD:
      m_rBatterySOC += 0.000030 * rMilliSec;
      break;
    case thsStopAndEngine:
      m_rBatterySOC += 0.00010 * rMilliSec;
      break;
    case thsStop:
      break;
    }
  }

  /**
   * GW̉]擾
   * @return GW̉](rpm)
   */
  public double getEngineRpm() {
    return m_planetaryGear.getPlaCarrierSpeed();
  }
  /**
   * ԑ擾
   * @return ԑ(km/h)
   */
  public double getSpeed() {
//    double rTyreDiameter = 165 * 0.65 * 2 + 15 * 25.4;
    double rTyreDiameter = 285 * 2;
    double rTyreGirth = rTyreDiameter * Math.PI;
    return (m_planetaryGear.getRingGearSpeed() / 3.927 * rTyreDiameter * Math.PI * 60 / 1000 / 1000);
  }

  /**
   * V~[VɎgvl^MAIuWFNg
   * @return vl^MAIuWFNg
   */
  public PlanetaryGear getPlanetaryGear() {
    return m_planetaryGear;
  }

  /**
   * THS(Toyota Hybrid System) ̏Ԃ擾
   * @return THS ̏
   */
  public int getThsMode() {
    return m_nThsMode;
  }

  /**
   * K\Ă邩
   * @return K\ĂƂ true
   */
  public boolean isGasoline() {
    return m_bGasoline;
  }
  /**
   * [^[gpĂ邩
   * @return [^[őĂ邩GWAVXgĂƂ true
   */
  public boolean isMotor() {
    return m_bMotor;
  }
  /**
   * 񐶃u[L쒆
   * @return 񐶃u[L쒆̂Ƃ true
   */
  public boolean isKaisei() {
    return m_bKaisei;
  }

  /**
   * vl^MÃOMAi[^[Et@CiMA֐ڑj
   * @return vl^MÃOMA
   */
  public Gear getRingGear() {
    return m_planetaryGear.getRingGear();
  }
  /**
   * vl^MÃvl^LAiGWɒj
   * @return vl^MÃvl^LA
   */
  public PlanetaryCarrier getPlanetaryCarrier() {
    return m_planetaryGear.getPlanetaryCarrier();
  }
  /**
   * vl^MÃTMAid@ɒj
   * @return vl^MÃTMA
   */
  public Gear getSunGear() {
    return m_planetaryGear.getSunGear();
  }

  /**
   * OMẢ]x擾
   * @return OMẢ]x(rpm)
   */
  public double getRingGearSpeed() {
    return m_planetaryGear.getRingGearSpeed();
  }
  /**
   * vl^LẢ]x擾
   * GW]ƓƂȂ
   * @return vl^LẢ]x(rpm)
   */
  public double getPlaCarrierSpeed() {
    return m_planetaryGear.getPlaCarrierSpeed();
  }
  /**
   * TMẢ]x擾
   * d@̉]ƂȂ
   * @return TMẢ]x(rpm)
   */
  public double getSunGearSpeed() {
    return m_planetaryGear.getSunGearSpeed();
  }
  /**
   * obe[cʂ擾
   * @return obe[c(%)
   */
  public double getBatterySOC() {
    return m_rBatterySOC;
  }
  /**
   * obe[cʂA[d̕KvƂ true
   * GWɊ|ԂƂȂ
   * @return [d̕KvƂ true
   */
  public boolean isEngineRequest() {
    return m_bEngineRequest;
  }
  /**
   * o͐xiJj̕\Ԃ𔻒
   * @return o͐x_ĂƂ true
   */
  public boolean isPowerSaveMode() {
    return m_bPowerSaveMode;
  }

  /**
   * O drive \bhŎgpꂽRgp(L)
   * @param rMilliSec oߕb
   * @return Rgp(L)
   */
  protected double getUseFuel(double rMilliSec) {
    double rUseFuel = 0;
    String sShiftPosition = getShiftPosition();
    if (isGasoline()) {
      double rBatteryRatio = 1.0 + (m_rBatterySOC - 60.0) / 20.0 * 0.10;  //  obe[rnbƂđΔRǂAȂΔR
      if (sShiftPosition.equals("D") || sShiftPosition.equals("R"))
        rUseFuel = Math.pow(getEngineRpm() / 1000, 1.4) * 1.7 / 3600 / 1000 * rMilliSec / rBatteryRatio;
      else
        rUseFuel = Math.pow(getEngineRpm() / 1000, 1.5) * 1.54 / 3600 / 1000 * rMilliSec / rBatteryRatio;
    }
    return rUseFuel;
  }
}